<template>
  <div id="Form-Product">
    <h1>Nuevo Producto</h1>

    <FormAddNewProduct
      :items="items"
      :idActualUser="idActualUser"
      @upload-new-product="saveNewProduct"
    />
  </div>
</template>

<script>
import FormAddNewProduct from './FormAddNewProduct'
import API from '@/API.js'

export default {
  name: 'FormProductPage',
  components: {
    FormAddNewProduct
  },
  props: {
    idActualUser: String,
    actualUserRole: String
  },
  data() {
    return {
      categories: [],
      items: []
    }
  },
  async mounted() {
    await this.loadCategories()
    this.items = this.categories.map(sweetItem => {
      return sweetItem['categoryName']
    })
  },

  methods: {
    async loadCategories() {
      this.categories = await API.loadCategoriesName()
    },

    async saveNewProduct(product) {
      await API.saveNewProduct(product)
      if (this.actualUserRole.role === 'admin') {
        let idActualUser = this.idActualUser
        this.$router.push('/productList/' + idActualUser)
      } else if (this.actualUserRole.role === 'vendedor') {
        this.goToUserPanelPage()
      } else {
        this.goToUserPanelPage()
      }
    },
    goToUserPanelPage() {
      let idActualUser = this.idActualUser
      this.$router.push('/MyProduct/MyProductsPage/' + idActualUser)
    }
  }
}
</script>

<style scoped>
#product-details {
  display: flex;
  justify-content: space-around;
}
</style>
